
/*
**  Myio.h - Sample code for simple I/O functions ============== 02/01/19 =  **
**         - added dfines dans I/O functionrs for lcd_rgb ====== 12/12/19 =  **
**                                                                           **
**                                                                           **
**  =======================================================================  **
*/

/* Defines of the myio module ---------------------------------------------- */

#define DRVASY                      0  // ASY  driver identifier
#define DRVGPIO                     1  // GPIO driver identifier
#define DRVLED                      2  // LED  driver identifier
#define DRVKBD                      3  // KBD  driver identifier
#define DRVDAC                      4  // DAC  driver identifier
#define MAX_MODD                    5  // Count of used drivers

#define DEV0                        0  // device "DEV0"
#define DEV1                        1  // device "DEV1"
#define DEV2                        2  // device "DEV1"
#define MAX_DEV                     3  // Maximum count of devices per driver

/* Defines of the lcd_rgb  module------------------------------------------- */

#define SCREEN_INIT              0     // I2C command - Screen initialisation
#define SET_LINE1                1     // I2C command - Cursor on line 1
#define SET_LINE2                2     // I2C command - Cursor on line 2

#define RED                   0x04     // I2C register - RGB background color.
#define GREEN                 0x03     // I2C register - RGB background color.
#define BLUE                  0x02     // I2C register - RGB background color.




/* Interface procedures prototypes ----------------------------------------- */

int myio_open          (int,int,const char*,int*                             );
int myio_close         (int                                                  );
int myio_alloc_sub     (int,const char*,int*                                 );
int myio_free_sub      (int                                                  );
int myio_getval        (int,char*,int                                        );
int myio_setval        (int,const char*                                      );
int myio_givetok       (int,int,int,int*                                     );
int myio_write         (int,unsigned char*,int                               );
int myio_send          (int,unsigned char*,int,int*                          );

/* Interface procedures prototypes for lcd_rgb ----------------------------- */

void set_command(int)     ; // Prototype
void write_string(char*)  ; // Prototype
void set_color(int,int)   ; // Prototype
